{% load applications_tags %}
<div class="language-mapper" id="{{ widget.attrs.id }}__wrapper">
  <input type="hidden" name="{{ widget.name }}__data" value="{{ value_json }}">
  <div class="language-mapper--select">
    {% include "django/forms/widgets/select.html" %}
  </div>
  <div class="language-mapper--levels">
  </div>
</div>
<template id="language-mapper--template">
  <div class="language-mapper-level">
    <label class="language"></label>
    <select required>
      <option disabled selected value="">--</option>
      <option value=0>Basic (A1-A2)</option>
      <option value=1>Good (B1-B2)</option>
      <option value=2>Fluent (C1-C2)</option>
      <option value=3>Native Speaker</option>
    </select>
  </div>
</template>
<script>
  window.addEventListener('load', event => {
      const wrapper = document.getElementById("{{ widget.attrs.id }}__wrapper")
      const languageNames = Object.fromEntries(
          Array.from(
              wrapper.querySelectorAll('option')
            ).map(option => [option.value, option.label])
        )

      const select = document.getElementById("{{ widget.attrs.id}}")
      const hiddenInput = wrapper.querySelector('input[name="{{ widget.name }}__data"]')
      let value = Object.fromEntries(
          JSON.parse(hiddenInput.value).map(({language, points}) => [language, points])
        )
      const slidersContainer = wrapper.querySelector('.language-mapper--levels')
      const sliderTemplate = document.getElementById("language-mapper--template")

      function writeValueToHiddenInput() {
          hiddenInput.value = JSON.stringify(
              Object.entries(value).map(([language, points]) => ({language, points}))
            );
      }


      function addLanguage(language, points) {
          const newSlider = sliderTemplate.content.cloneNode(true)
          newSlider.querySelector('div').dataset.language = language
          newSlider.querySelector('label').textContent = languageNames[language]
          const select = newSlider.querySelector('select')
          if (points !== null) {
            select.value = points
          }
          select.addEventListener('change', (event) => {
              value[language] = select.value
              writeValueToHiddenInput()
          })


          slidersContainer.appendChild(newSlider)
      }

      function removeLanguage(language) {
          delete value[language]
          writeValueToHiddenInput()

          slidersContainer.querySelector(`[data-language="${language}"]`).remove()
        }

      Object.entries(value).forEach(([language, points]) => addLanguage(language, points))

      select._choices = new Choices(select, {
          removeItemButton: true,
          duplicateItemsAllowed: false,
        })

      select.addEventListener("addItem", (event) => addLanguage(event.detail.value, null))
      select.addEventListener("removeItem", (event) => removeLanguage(event.detail.value))
  })
</script>
